



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java微信接口之——获取access_token</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java微信接口之——获取access_token</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 19:07:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>本文转自<a href="http://www.cnblogs.com/always-online/category/598553.html" rel="external nofollow noreferrer">http://www.cnblogs.com/always-online/category/598553.html</a></p>
<p>一、微信获取access_token接口简介</p>
<p>　　1、请求：该请求是GET方式请求，所以要携带的参数都是附加到url后面传递给微信服务器。请求的url格式如下：</p>
<p>　　　　https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&amp;appid=APPID&amp;secret=APPSECRET<br />　　　　其中，APPID与APPSECRET都我们开发的时候自己帐号申请的。<br />　　2、响应：返回数据都是json数据，格式如下：<br />　　　正确的时候返回的数据： {"access_token":"ACCESS_TOKEN","expires_in":7200}</p>
<p>　　　　　ACCESS_TOKEN：访问token，expires_in为过期时间<br />　　　错误的时候返回的数据： {"errcode":40013,"errmsg":"invalid appid"}</p>
<p>　　　　　errcode，为错误代码，errmsg为错误信息<br />　　　具体api说明可查看文档：<a href="http://mp.weixin.qq.com/wiki/index.php?title=%E8%8E%B7%E5%8F%96access_token" rel="external nofollow noreferrer">http://mp.weixin.qq.com/wiki/index.php?title=%E8%8E%B7%E5%8F%96access_token</a>&nbsp;。</p>
<p>二、关于java代码的调用</p>
<p>　　该接口可以在前台用页面ajax调用，也可以在后台用java代码调用。这里需要使用到apache的http组件httpcomponents-client，这里使用的版本为httpcomponents-client-4.2.1，下载地址为：<a href="http://hc.apache.org/downloads.cgi" rel="external nofollow noreferrer">http://hc.apache.org/downloads.cgi</a>。需要使用到的jar文件如下：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/i/586854/201407/262149157751447.png" /></p>
<p>三、代码实现</p>
<div>
<div><img referrerpolicy="no-referrer"src="http://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1 package com.demo.test;
 2
 3 import org.apache.http.HttpEntity;
 4 import org.apache.http.HttpResponse;
 5 import org.apache.http.HttpStatus;
 6 import org.apache.http.client.HttpClient;
 7 import org.apache.http.client.methods.HttpGet;
 8 import org.apache.http.impl.client.DefaultHttpClient;
 9 import org.apache.http.util.EntityUtils;
10
11 import com.google.gson.JsonObject;
12 import com.google.gson.JsonParser;
13
14 public class Test
15 {
16     public static final String GET_TOKEN_URL = "https://api.weixin.qq.com/cgi-bin/token";// 获取access
17                                                                                             // url
18     public static final String APP_ID = "wxa549b28c24cf341e";
19     public static final String SECRET = "78d8a8cd7a4fa700142d06b96bf44a37";
20
21     // 获取token
22     public static String getToken(String apiurl, String appid, String secret)
23     {
24         String turl = String.format(
25                 "%s?grant_type=client_credential&amp;appid=%s&amp;secret=%s", apiurl,
26                 appid, secret);
27         HttpClient client = new DefaultHttpClient();
28         HttpGet get = new HttpGet(turl);
29         JsonParser jsonparer = new JsonParser();// 初始化解析json格式的对象
30         String result = null;
31         try
32         {
33             HttpResponse res = client.execute(get);
34             String responseContent = null; // 响应内容
35             HttpEntity entity = res.getEntity();
36             responseContent = EntityUtils.toString(entity, "UTF-8");
37             JsonObject json = jsonparer.parse(responseContent)
38                     .getAsJsonObject();
39             // 将json字符串转换为json对象
40             if (res.getStatusLine().getStatusCode() == HttpStatus.SC_OK)
41             {
42                 if (json.get("errcode") != null)
43                 {// 错误时微信会返回错误码等信息，{"errcode":40013,"errmsg":"invalid appid"}
44                 }
45                 else
46                 {// 正常情况下{"access_token":"ACCESS_TOKEN","expires_in":7200}
47                     result = json.get("access_token").getAsString();
48                 }
49             }
50         }
51         catch (Exception e)
52         {
53             e.printStackTrace();
54         }
55         finally
56         {
57             // 关闭连接 ,释放资源
58             client.getConnectionManager().shutdown();
59             return result;
60         }
61     }
62
63     public static void main(String[] args) throws Exception
64     {
65         System.out.println("=========1获取token=========");
66         String accessToken = getToken(GET_TOKEN_URL, APP_ID, SECRET);// 获取token
67         if (accessToken != null)
68             System.out.println(accessToken);
69     }
70
71 }</pre>
<div><img referrerpolicy="no-referrer"src="http://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>　　当token正常返回的时候会打印token，否则不会打印。</p>
</div>
<div>&nbsp;</div>
<div>
<div>分类:&nbsp;<a href="http://www.cnblogs.com/always-online/category/598553.html" rel="external nofollow noreferrer">微信</a></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7vm1qe.html">WPF自定义RoutedEvent事件代码段</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxlxkeq.html">ASP&period;NET SignalR 与 LayIM2&period;0 配合轻松实现Web聊天室 实战系列</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mly0p9.html">HDU 5055 Bob and math problem（简单贪心）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq47y35q.html">Python中获取异常（Exception）信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q73p7x8.html">IIS7&sol;IIS7&period;5中目录执行权限的设置方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjd0679.html">google和ebay微服务经验</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xw2lw9.html">C语言中的atan和atan2（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mljzxq.html">在RHEL5&period;4下安装ORACLE11G</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oklz7e9.html">RocketMQ在linux平台下环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdgeoz8.html">&lpar;转&rpar; Android平台上关于IM的实践总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0w6ggq.html">Android混淆配置文件规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo1vg1q.html">HDU 4839 The Game of Coins &lowbar;&lpar;&colon;&zcy;ゝ&angle;&rpar;&lowbar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jjeml8.html">获取鼠标点击相对于Canva位置的2种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1eez1q.html">codevs1993草地排水（最大流）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jmndv8.html">利用JS做到隐藏div和显示div</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r2vdn9.html">Laravel 数据库操作 Eloquent ORM</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oen3j8.html">在Xshell 6开NumLock时按小键盘上的数字键并不能输入数字</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyv7dx9.html">数据分析---用pandas进行数据清洗（Data Analysis Pandas Data Munging&sol;Wrangling）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjv5259.html">JS RegExp类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5o1ndq.html">Opencv&lpar;3&rpar;&colon;基本数据类型</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r8mzoerq.html">The method below converts an array of objects to a DataTable object in C&num;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zx5y1q.html">LINQ的左连接、右连接、内连接</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jgy3e9.html">Java &percnt;c0&percnt;ae 安全模式绕过漏洞</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2v7p38.html">sqlmap的一些小技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pe11k8.html">Effective Objective-C 2&period;0 &mdash; 第11条：理解 objc&lowbar;msgSend  的作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnkmwxq.html">PHP isset 函数作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jr0yeq.html">&lbrack;Js&sol;Jquery&rsqb;Jquery tagsinput在h5邮件客户端中应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e744e9.html">R--基本统计分析方法（包及函数）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kljw5q.html">InnerClass内部类</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1nvp59.html">采用ETL with RDBMS模式来实现ETL</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
